<h4>Neon Query Editor</h4>
<hr>
<!-- Databases -->
<div class="input-group mb-3">
    <div class="input-group-prepend">
        <span class="input-group-text">Databases</span>
    </div>
    <select class="form-control" [ngModel]="selectedDb" (ngModelChange)="onDbSelected($event)" [disabled]="!isNeonReady">
        <option [ngValue]="null" disabled selected="true">—</option>
        <option *ngFor="let dbName of dbNames" [ngValue]="dbName">{{ dbName }}</option>
    </select>
</div>
<!-- Tables -->
<div class="input-group mb-3">
    <div class="input-group-prepend">
        <span class="input-group-text">Tables</span>
    </div>
    <select class="form-control" [ngModel]="selectedTable" (ngModelChange)="onTableSelected($event)" [disabled]="!this.tableNames.length || !isNeonReady">
        <option [ngValue]="null" disabled selected>—</option>
        <option *ngFor="let tableName of tableNames" [ngValue]="tableName">{{ tableName }}</option>
    </select>
</div>
<h5>Select Multiple Query Fields</h5>
<div class="row">
    <div *ngFor="let fieldName of fieldNames" class="col-md-4">
        <div class="checkbox">
            <label>
                <input class="checkbox-inline" type="checkbox" [ngModel]="selectedField" (ngModelChange)="onFieldSelected($event, fieldName)" [disabled]="aggregationInProgress()">
                {{fieldName}}
            </label>
        </div>
    </div>
</div>

<hr>
<h5>Aggregation</h5>
<!-- Aggregation Operation -->
<div class="input-group mb-3">
    <div class="input-group-prepend">
        <span class="input-group-text">Agg. Operation</span>
    </div>
    <!-- Operation -->
    <select class="form-control" [ngModel]="selectedAggOperator" (ngModelChange)="onAggOperatorSelected($event)" [disabled]="!hasFields() || hasFieldsInList()">
        <option [ngValue]="null">—</option>
        <option value="count">COUNT</option>
        <option value="avg">AVG</option>
        <option value="min">MIN</option>
        <option value="max">MAX</option>
    </select>
    <!-- Field -->
    <div class="input-group-prepend">
        <span class="input-group-text">Field</span>
    </div>
    <select class="form-control" [ngModel]="selectedAggField" (ngModelChange)="onAggFieldSelected($event)" [disabled]="!hasFields() || hasFieldsInList()">
        <option [ngValue]="null">—</option>
        <option *ngFor="let fieldName of fieldNames" [value]="fieldName">{{ fieldName }}</option>
    </select>
</div>
<!-- Group By -->
<div class="input-group mb-3">
    <div class="input-group-prepend">
        <span class="input-group-text">Group By</span>
    </div>
    <select class="form-control" [ngModel]="selectedGroupByField" (ngModelChange)="onAggGroupByFieldSelected($event)" [disabled]="!hasFields() || hasFieldsInList()">
        <option [ngValue]="null">—</option>
        <option *ngFor="let fieldName of fieldNames" [value]="fieldName">{{ fieldName }}</option>
    </select>
</div>
<hr>
<h5>Filtering (AND)</h5>
<!-- Filtering -->
<table class="table table-bordered">
    <thead>
        <tr>
            <th class="col-xs-4">Field</th>
            <th>Operator</th>
            <th>Value</th>
            <th class="col-xs-2">Remove</th>
        </tr>
    </thead>
    <tbody>
        <tr *ngFor="let filter of filters; let i = index;">
            <td>
                <select class="form-control" [(ngModel)]="filter.field" (ngModelChange)="onFilterFieldSelected($event)">
                    <option [ngValue]="null" disabled>—</option>
                    <option *ngFor="let fieldName of fieldNames" [value]="fieldName">{{ fieldName }}</option>
                </select>
            </td>
            <td>
                <select class="form-control" [(ngModel)]="filter.operator">
                    <option value="=">=</option>
                    <option value="!=">!=</option>
                    <option value=">">&gt;</option>
                    <option value="<">&lt;</option>
                    <option value=">=">&gt;=</option>
                    <option value="<=">&lt;=</option>
                    <option value="contains">contains</option>
                    <option value="not contains">not contains</option>
                </select>
            </td>
            <td>
                <input class="form-control" [(ngModel)]="filter.value">
            </td>
            <td>
                <button class="btn btn-block btn-danger" (click)="removeFilter(i)">Remove</button>
            </td>
        </tr>
        <tr *ngIf="!filters.length">
            <td colspan="4" class="text-center">No Filters</td>
        </tr>
        <tr>
            <td colspan="4">
                <button class="btn btn-block btn-default" (click)="addFilter()" [disabled]="!hasFields()">Add Filter</button>
            </td>
        </tr>
    </tbody>
</table>
<hr>
<h5>Limit</h5>
<select class="form-control" [(ngModel)]="selectedLimit" [disabled]="!canSendQuery()">
    <option value="100">100</option>
    <option value="1000">1,000</option>
    <option value="5000">5,000</option>
    <option value="10000">10,000</option>
    <option value="50000">50,000</option>
</select>
<hr>
<!-- Response as JSON (Test) -->
<textarea class="form-control" rows="8" placeholder="Response..." [disabled]="!selectedTable">{{ lastResponse | json }}</textarea>
<hr>
<button class="btn btn-block btn-success" (click)="sendQuery()" [disabled]="!canSendQuery()" *ngIf="isNeonReady">
    Send Query
    <i class="fa fa-spinner fa-spin" *ngIf="processing"></i>
</button>
<!-- Connection -->
<button class="btn btn-block btn-success" (click)="connectToNeon()" *ngIf="!isNeonReady" [disabled]="processing">
    Connect to Neon Server
    <i class="fa fa-spinner fa-spin" *ngIf="processing"></i>
</button>